<?php
$_REQUEST['refurl'] = $_SERVER['HTTP_REFERER'];
$_REQUEST['currenturl'] = currenturl();

// begin common section (also in ajaxhandler.php)

require 'config.php';
if (file_exists('data.php')) { require 'data.php'; }
//file_put_contents("1.txt", "refurl={$_REQUEST['refurl']} currenturl={$_REQUEST['currenturl']}"); // debugging
if (isset($_REQUEST['refurl']) && isset($redirects) && applicableref())
{
 $refurl = $_REQUEST['refurl'];
 $page = $_REQUEST['currenturl'];
 $output = '';
 $currentpriority = 9999;
 $n = count($redirects);
 for ($x=0; $x<$n; $x++)
 {
  if (strstr(urltokeywords($refurl), urltokeywords($redirects[$x]['term'])))
  {
   if (!$output || (is_numeric($redirects[$x]['priority']) && $redirects[$x]['priority'] < $currentpriority))
   {
    $output = $redirects[$x]['url'];
    $currentpriority = $redirects[$x]['priority'];
   }
  }
 }
// end common section (also in ajaxhandler.php)

 
// begin common section (also in ajaxhandler.php)

// now do stats tracking if possible, if and only if there was output (meaning, only track if we did a redirection, for now anyway)

 if ($output && function_exists('sqlite_exec') && is_writeable('statsdb.sqlite'))
 {
  if ($db = new SQLiteDatabase('statsdb.sqlite'))
  {
   if ($q !== false)
   {
    $t = time();
    $query = "INSERT INTO stats VALUES (NULL, $t, '$page', '$refurl', '$output');";
//echo $query; // for debugging
    $db->queryExec($query);
   }
  }
 }

// end common section (also in ajaxhandler.php)

 if ($output) header("Location: $output");

}

function applicableref()
{ // check if this is a referring url we should redirect on
 global $conf;
 $ret = true;

 $refurl = $_REQUEST['refurl'];

 // in order to redirect on "webmastersite.net" term, only check for domain at start of url
 $endbit = end($x = explode('/', $refurl));
 $applic = str_replace($endbit, '', $refurl);

 if (isset($conf) && $conf['applyfrom'] == 'outside' && strstr($applic, currentdomain())) $ret = false;
 if (isset($conf) && $conf['applyto'] == 'index' && !isindex()) $ret = false;
 return $ret;
}

function urltokeywords($url)
{ // replace +, %20 with spaces... and other stuff maybe
 $url = urldecode($url);
 return $url;
}

function isindex()
{
 $ret = false;
 $url = $_REQUEST['currenturl'];
 if (strstr($url, 'index')) $ret = true;
 $domainless = str_replace(currentdomain(), '', $url);
 if (!strstr($domainless, '.')) $ret = true; // must be a site.com/directory/ page, which is an index
 return $ret;
}

function currentdomain()
{
  return str_replace('www.', '', $_SERVER['SERVER_NAME']);
}

function currenturl()
{
  if (strstr($_SERVER['SERVER_PROTOCOL'], 'HTTPS')) $protocol = 'https://';
  else $protocol = 'http://';
  $url = $protocol . $_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'];
  if ($_SERVER['QUERY_STRING'] && !strstr($url, $_SERVER['QUERY_STRING'])) $url .= '?'. $_SERVER['QUERY_STRING'];
  return $url; 
}


?>